<template>
  <div class="container">
    <div class="row">
      <div class="form-group col-md-4">
        <label class="control-label">
          ¿ Tiene cuentas por cobrar ?
        </label>
        <p-radio class="d-inline-block" v-model="bandera" label="1">Si</p-radio>
        <p-radio class="d-inline-block" v-model="bandera" label="0">No</p-radio>
      </div>
    </div>
    <div v-if="bandera == '1'">
      <div v-if="add_item">
        <div class="row">
          <legend>Cuentas por cobrar</legend>
        </div>
        <div class="row">

          <div class="form-group col-md-4">
            <label class="control-label">Nombre del prestatario </label>
            <input class="form-control" type="text" v-model="item_cuentas.nombre" placeholder="Nombre del prestatario">
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Número de registro</label>
            <input class="form-control" type="text" v-model="item_cuentas.numero_registro" placeholder="Número de registro">
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Sector / Industria (si aplica)</label>
            <el-select  clearable class="select-default" placeholder="Seleccione una opción" v-model="item_cuentas.sector_industria_id">
              <el-option v-for="option in sectores" class="select-default" :value="option.id" :label="option.valor" :key="option.label"></el-option>
            </el-select>
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Fecha del préstamo</label>
            <el-date-picker v-model="item_cuentas.fecha_prestamo" type="date" placeholder="Seleccione fecha" value-format="dd-MM-yyyy" format="dd-MM-yyyy"></el-date-picker>
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Monto original del préstamo</label>
            <input class="form-control" type="text" v-model="item_cuentas.monto_original_prestamo" placeholder="Monto original del préstam">
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Tasa de interés ( % )</label>
            <el-input-number v-model="item_cuentas.tasa_interes" controls-position="right" :step="5" :min="0" :max="100"></el-input-number>
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Saldo Pendiente</label>
            <input class="form-control" type="text" v-model="item_cuentas.saldo_pendiente" placeholder="Saldo Pendiente">
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Fecha de vencimiento</label>
            <el-date-picker v-model="item_cuentas.fecha_vencimiento" type="date" placeholder="Seleccione fecha" value-format="dd-MM-yyyy" format="dd-MM-yyyy"></el-date-picker>
          </div>
          <div class="form-group col-md-4">
            <label class="control-label">Porcentaje de propiedad en caso de copropiedad ( % )</label>
            <el-input-number v-model="item_cuentas.porcentaje_copropiedad" controls-position="right" :step="5" :min="0" :max="100"></el-input-number>
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Nombre del copropietario</label>
            <input class="form-control" type="text" v-model="item_cuentas.nombre_copropietario" placeholder="Nombre del copropietario">
          </div>

          <div class="form-group col">
            <label class="control-label">Observaciones / Comentarios</label>
            <input class="form-control" type="text" v-model="item_cuentas.observaciones" placeholder="Observaciones / Comentarios">
          </div>
        </div>

        <domicilio titulo="de prestatarios (si aplica)" v-model="n_domicilio"></domicilio>

        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="addItem()">
            <span v-if="edit_item == null">
              <i class="fa fa-plus"></i> Agregar
            </span>

            <span v-else>
              <i class="fa fa-save"></i> Guardar
            </span>
          </button>
          <button class="btn btn-danger ml-3" @click.prevent="cancelEdit()">
            <span>
              <i class="fa fa-times"></i> Cancelar
            </span>
          </button>
        </div>
        <div class="row">
          <hr class="col-md-12 bg-info">
        </div>
      </div>
      <div v-if="!add_item">
        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="showItem()">
            <span>
              <i class="fa fa-plus"></i> Agregar
            </span>
          </button>
        </div>
        <div class="row mt-3 mb-4">
          <div class="col-sm-12 col-md-12 col-lg-12">
            <b-table id="tbl_cuentas_por_cobrar" responsive hover :items="list_cuentas" :fields="fields_list" show-empty>
              <!-- :fields="fields_list" -->
              <template slot="acciones" slot-scope="row" class="actions">
                <b-button size="sm" @click.prevent="editItem(row)" class="edit mr-2" :disabled="edit_item != null">
                  Editar <i class="fas fa-pencil-alt ml-2"></i>
                </b-button>
                <b-button size="sm" @click.prevent="removeItem(row.index)" class="delete mr-2" :disabled="edit_item != null">
                  Eliminar <i class="fas fa-trash-alt ml-2"></i>
                </b-button>
              </template>
              <template slot="empty">
                <h5>No existen registros</h5>
              </template>

              <template slot="domicilio_entidad_federativa_id" slot-scope="row">
                {{getEntidad(row.item.domicilio_entidad_federativa_id)}}</template>
              <template slot="domicilio_localidad_id" slot-scope="row">
                {{getLocalidad(row.item.domicilio_localidad_id)}}
              </template>
              <template slot="domicilio_municipio_id" slot-scope="row">{{getMunicipio(row.item.domicilio_municipio_id)}}</template>
              <template slot="domicilio_pais_id" slot-scope="row">{{getPais(row.item.domicilio_pais_id)}}</template>

              <template slot="porcentaje_propiedad" slot-scope="row" class="text-center">{{row.item.porcentaje_propiedad}} %</template>

              <template slot="monto_original_prestamo" slot-scope="row" class="text-right">{{(getSignoDos(97))}}
                {{row.item.monto_original_prestamo | currency}}</template>
              <template slot="monto_original_prestamo" slot-scope="row" class="text-right">{{(getSignoDos(97))}}
                {{row.item.saldo_pendiente | currency}}</template>

              <template slot="sector_industria_id" slot-scope="row">{{getSector(row.item.sector_industria_id)}}</template>
              <template slot="tasa_interes" slot-scope="row" class="text-center">{{row.item.tasa_interes}} %</template>
              <template slot="porcentaje_copropiedad" slot-scope="row" class="text-center">{{row.item.porcentaje_copropiedad}} %</template>

            </b-table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
  import {
    Tag,
    Select,
    DatePicker,
    InputNumber
  } from "element-ui";
  import Domicilio from "../Domicilio.vue";
  import {
    mapFields
  } from "vee-validate";
  export default {
    components: {
      [Tag.name]: Tag,
      [DatePicker.name]: DatePicker,
      [InputNumber.name]: InputNumber,
      Domicilio
    },
    props: ["data"],
    data() {
      return {
        ip_id: 1,
        add_item: false,
        edit_item: null,
        bandera: '0',
        modelValidations: {
          nombre: {
            min: 5
          },
          email: {
            required: true,
            email: true
          }
        },
        sectores: null,
        n_domicilio: null,
        monedas: [],
        entidadFed: null,
        municipios: null,
        localidades: null,
        localidad: null,
        paises: null,
        isnum: null,
        /* Lista de Bienes */
        item_cuentas: {},
        list_cuentas: [],
        fields_list: [{
            key: "acciones",
            label: "Acciones",
            tdClass: "text-center"
          },
          {
            key: "nombre",
            label: "Nombre del prestatario",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "numero_registro",
            label: "Número de registro",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "sector_industria_id",
            label: "Sector / Industria ",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "fecha_prestamo",
            label: "Fecha del préstamo",
            tdClass: "text-center",
            formatter: 'emptyFields'
          },
          {
            key: "monto_original_prestamo",
            label: "Monto original del préstamo",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "tasa_interes",
            label: "Tasa de interés",
            tdClass: "text-center",
            formatter: 'emptyFields'
          },
          {
            key: "saldo_pendiente",
            label: "Saldo pendiente",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "fecha_vencimiento",
            label: "Fecha de vencimiento",
            tdClass: "text-center",
            formatter: 'emptyFields'
          },
          {
            key: "porcentaje_copropiedad",
            label: "Porcentaje de propiedad",
            tdClass: "text-center",
            formatter: 'emptyFields'
          },
          {
            key: "nombre_copropietario",
            label: "Nombre del copropietario",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "observaciones",
            label: "Observaciones / Comentarios",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_pais_id",
            label: "País",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_entidad_federativa_id",
            label: "Entidad federativa",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_municipio_id",
            label: "Municipio",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_localidad_id",
            label: "Localidad",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_colonia",
            label: "Colonia",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_vialidad_tipo",
            label: "Tipo vialidad",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_vialidad_nombre",
            label: "Nombre vialidad",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_cp",
            label: "CP",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_numExt",
            label: "Número exterior",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_numInt",
            label: "Número interior",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
        ]
      };
    },
    computed: {},
    watch: {
      n_domicilio: {
        handler: function () {
          if (this.n_domicilio) {
            this.item_cuentas.domicilio_pais_id = this.n_domicilio.pais_id ? this.n_domicilio.pais_id : 150;
            this.item_cuentas.domicilio_entidad_federativa_id = this.n_domicilio.entidadF ? this.n_domicilio.entidadF : "";
            this.item_cuentas.domicilio_municipio_id = this.n_domicilio.municipio ? this.n_domicilio.municipio : "";
            this.item_cuentas.domicilio_localidad_id = this.n_domicilio.localidad ? this.n_domicilio.localidad : "";
            this.item_cuentas.domicilio_cp = this.n_domicilio.cp ? this.n_domicilio.cp : "";
            this.item_cuentas.domicilio_colonia = this.n_domicilio.colonia ? this.n_domicilio.colonia : "";
            this.item_cuentas.domicilio_vialidad_tipo = this.n_domicilio.vialidad ? this.n_domicilio.vialidad : "";
            this.item_cuentas.domicilio_vialidad_nombre = this.n_domicilio.vialidad_nombre ? this.n_domicilio.vialidad_nombre : "";
            this.item_cuentas.domicilio_numExt = this.n_domicilio.ext ? this.n_domicilio.ext : "";
            this.item_cuentas.domicilio_numInt = this.n_domicilio.int ? this.n_domicilio.int : "";
          }
        },
        deep: true
      },
      list_cuentas: {
        handler: function () {
          if (this.list_cuentas) {
            this.setLocalidades();
            if (this.list_cuentas.length == 0) {
              this.bandera = '0';
            } else {
              this.bandera = '1';
            }
          }
        },
        deep: true
      },
    },
    methods: {
      getSignoDos(val = "97") {
        var signo = "$";
        this.monedas.forEach(function (item) {
          if (item.id == val) {
            signo = item.signo;
          }
        });
        return signo;
      },
      emptyFields(value) {
        if (value) {
          if (typeof value === 'string' || value instanceof String) {
            return value.toUpperCase();
          } else {
            return value;
          }
        } else {
          return '-';
        }
      },
      getEntidad(index) {
        var resp = " ";
        if (this.entidadFed) {
          this.entidadFed.forEach(function (item) {
            if (item.id == index) {
              resp = item.nom_ent;
              return resp;
            }
          });
        }
        return resp;
      },
      getSector(index) {
        var resp = " ";
        if (this.sectores) {
          this.sectores.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getMoneda(index) {
        var resp = "";
        if (this.monedas) {
          this.monedas.forEach(function (item) {
            if (item.id == index) {
              resp = item.moneda;
            }
          });
        }
        return resp;
      },
      getLocalidad(index) {
        var resp = "";
        if (this.localidades) {
          this.localidades.forEach(function (item) {
            if (item.id == index) {
              resp = item.nom_loc;
              return resp;
            }
          });
        }
        return resp;
      },
      getMunicipio(index) {
        var resp = "";
        if (this.municipios) {
          this.municipios.forEach(function (item) {
            if (item.id == index) {
              resp = item.nom_mun;
              return resp;
            }
          });
        }
        return resp;
      },
      getPais(index) {
        var resp = "México";
        if (this.paises) {
          this.paises.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      initItem() {
        this.n_domicilio = {
          pais_id: 150,
          entidadF: '',
          municipio: '',
          localidad: '',
          cp: '',
          colonia: '',
          vialidad: '',
          vialidad_nombre: '',
          ext: '',
          int: ''
        };
        this.item_cuentas = {
          acciones: "",
          nombre: "",
          numero_registro: "",
          sector_industria_id: "",
          fecha_prestamo: "",
          monto_original_prestamo: "",
          tasa_interes: "",
          saldo_pendiente: "",
          fecha_vencimiento: "",
          porcentaje_copropiedad: "",
          nombre_copropietario: "",
          observaciones: "",
          domicilio_pais_id: 150,
          domicilio_entidad_federativa_id: "",
          domicilio_municipio_id: "",
          domicilio_localidad_id: "",
          domicilio_colonia: "",
          domicilio_vialidad_nombre: "",
          domicilio_vialidad_tipo: "",
          domicilio_cp: "",
          domicilio_numExt: "",
          domicilio_numInt: "",
          nombre_denominacion_quien_adquirio: "",
        };
      },
      showItem() {
        this.add_item = !this.add_item;
      },
      cancelEdit() {
        if (this.edit_item) {
          this.edit_item.item._rowVariant = "";
        }
        this.initItem();
        this.showItem();
        this.edit_item = null;
      },
      addItem() {
        if (this.item_cuentas) {
          this.item_cuentas.ip_id = this.ip_id;
          this.loadButton(this.$refs.btnSave);
          this.$http.post("cuentas_por_cobrar", this.item_cuentas).then(
            response => {
              this.StepOk("Guardado");
              if (this.edit_item === undefined || this.edit_item === null) {
                this.list_cuentas.push({
                  ...response.data.cuenta
                });
              } else {
                this.list_cuentas.splice(
                  this.edit_item.index,
                  1,
                  this.item_cuentas
                );
                this.edit_item.item._rowVariant = "";
              }
              this.showItem();
              this.initItem();
              this.edit_item = null;
            },
            error => {
              this.StepError(error);
              //this.change =  true;
            }
          );
        } else {
          this.StepW("Hay campos sin completar");
        }
        //console.log(this.item_cuentas);
      },
      editItem(indice) {
        this.showItem();
        this.edit_item = indice;
        this.item_cuentas = {
          ...this.list_cuentas[this.edit_item.index]
        };
        this.editDomicilio();
        this.edit_item.item._rowVariant = "danger";
        $(".main-panel").animate({
            scrollTop: 100
          },
          500,
          "swing"
        );
      },
      removeItem(indice) {
        if (this.list_cuentas[indice].id !== null) {
          let item = this.list_cuentas[indice];
          //this.list_cuentas.splice(indice, 1);
          this.Ask("Desea borrar este registro", () => {
            this.$http.delete("cuentas_por_cobrar/" + item.id).then(
              response => {
                /* eventBus.$emit("TramiteDelete", item); */
                this.list_cuentas.splice(indice, 1);
              },
              error => {
                this.Err(error);
              }
            );
          });
        }
      },
      editDomicilio() {
        this.n_domicilio.pais_id = this.item_cuentas.domicilio_pais_id ? this.item_cuentas.domicilio_pais_id : 150;
        this.n_domicilio.entidadF = this.item_cuentas.domicilio_entidad_federativa_id ? this.item_cuentas.domicilio_entidad_federativa_id : '';
        this.n_domicilio.municipio = this.item_cuentas.domicilio_municipio_id ? this.item_cuentas.domicilio_municipio_id : '';
        this.n_domicilio.localidad = this.item_cuentas.domicilio_localidad_id ? this.item_cuentas.domicilio_localidad_id : '';
        this.n_domicilio.cp = this.item_cuentas.domicilio_cp ? this.item_cuentas.domicilio_cp : '';
        this.n_domicilio.colonia = this.item_cuentas.domicilio_colonia ? this.item_cuentas.domicilio_colonia : '';
        this.n_domicilio.vialidad = this.item_cuentas.domicilio_vialidad_tipo ? this.item_cuentas.domicilio_vialidad_tipo : '';
        this.n_domicilio.vialidad_nombre = this.item_cuentas.domicilio_vialidad_nombre ? this.item_cuentas.domicilio_vialidad_nombre : '';
        this.n_domicilio.ext = this.item_cuentas.domicilio_numExt ? this.item_cuentas.domicilio_numExt : '';
        this.n_domicilio.int = this.item_cuentas.domicilio_numInt ? this.item_cuentas.domicilio_numInt : '';
      },
      validate() {
        return this.$validator.validateAll();
      },
      setLocalidades() {
        this.localidades = [];
        this.list_cuentas.forEach((item) => {
          if (item.domicilio_localidad_id) {
            this.$http.get('localidades/localidad/' + item.domicilio_localidad_id).then(
              response => {
                this.localidades.push(response.data.localidad);
              },
              error => {
                this.Err(error);
              }
            );
          }
        });
      },
      isNumber(n) {
        //console.log(n);
        n.target.value = n.target.value.replace(/[^\d.-]/g, '');
      }
    },
    created() {
      this.initItem();
      //this.getLocalidades(97250);
      this.$http.get("cuentas_por_cobrar/" + this.ip_id).then(
        response => {
          this.list_cuentas = response.data.cuentas;
          this.setLocalidades();
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("entidadFed").then(
        response => {
          this.entidadFed = response.data.entidadfed;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("paises").then(
        response => {
          this.paises = response.data.pais;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("municipios").then(
        response => {
          this.municipios = response.data.municipios;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("cat_sector_industria").then(
        response => {
          this.sectores = response.data.sectores;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("monedas").then(
        response => {
          this.monedas = response.data.monedas;
        },
        error => {
          this.Err(error);
        }
      );
      if (this.data) {}
    }
  };

</script>
<style>


</style>
